// Information for Spherekuro //
EvaluateScript("Menu.js");
EvaluateScript("Cursor.js");
EvaluateScript("Animation.js");
EvaluateScript("Fade Stuff.js");
EvaluateScript("Puzzles.js");
EvaluateScript("Data.js");

function Delay(milliseconds)
{
  var start = GetTime();
  while (start + milliseconds > GetTime()) {}
}

function Level(level)
{
	this.level = level;
	this.unlocked = false;
	this.difficulty = "";
}

function GetNumberKey()
{
	while(!AreKeysLeft())
	{
		switch(GetKey())
		{
			case KEY_1:
			case KEY_NUM_1:
				return 1;
			break;
			case KEY_2:
			case KEY_NUM_2:
				return 2;
			break;
			case KEY_3:
			case KEY_NUM_3:
				return 3;
			break;
			case KEY_4:
			case KEY_NUM_4:
				return 4;
			break;
			case KEY_5:
			case KEY_NUM_5:
				return 5;
			break;
			case KEY_6:
			case KEY_NUM_6:
				return 6;
			break;
			case KEY_7:
			case KEY_NUM_7:
				return 7;
			break;
			case KEY_8:
			case KEY_NUM_8:
				return 8;
			break;
			case KEY_9:
			case KEY_NUM_9:
				return 9;
			break;
		}
	}
}

function Return() {}

function Loader()
{
	sw            = GetScreenWidth();
	sh            = GetScreenHeight();
	font          = LoadFont("Font.rfn");
	window        = LoadWindowStyle("Window.rws");

	font.drawText(sw/2-font.getStringWidth("Loading: Stuff")/2,sh/2-8,"Loading: Stuff");
	FadeIn(512);
	
	font2         = LoadFont("Font2.rfn");
	font3         = LoadFont("Font3.rfn");
	music         = LoadSound("Spherekuro.mid",true);
	White         = CreateColor(255,255,255,255);
	Gray          = CreateColor(125,125,125,255);
	Black         = CreateColor(0  ,0  ,0  ,255);
	Red           = CreateColor(255,0  ,0  ,255);
	Green         = CreateColor(0  ,255,0  ,255);
	BabyBlue      = CreateColor(120,160,240,255);
	WhiteHaze     = CreateColor(255,255,255,125);
	GrayHaze      = CreateColor(125,125,125,125);
	BlackHaze     = CreateColor(0  ,0  ,0  ,125);
	
	ApplyColorMask(Black);
	font.drawText(sw/2-font.getStringWidth("Loading: Images/Animations")/2,sh/2-8,"Loading: Images/Animations");
	FlipScreen();

	image         = LoadImage("Spherekuro.png");
	background    = LoadImage("Background.png");
	QuitButton    = LoadImage("Quit Button.png");
	logo          = LoadImage("Logo.png");
	FeekPresents1 = LoadImage("FeekStart/FeekPresents 01.png");
	FeekPresents2 = LoadImage("FeekStart/FeekPresents 13.png");
	Tile          = LoadImage("Tile_Blank.png");
	NumberTile    = LoadImage("Tile_Number.png");
	NumberBlock1  = LoadImage("Tile_Number_Good1.png");
	NumberBlock2  = LoadImage("Tile_Number_Good2.png"); 
	
	FeekAnim = new Animation();
	FeekAnim.addFrame("FeekStart/FeekPresents 01.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 02.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 03.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 04.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 05.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 06.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 07.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 08.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 09.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 10.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 11.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 12.png");
	FeekAnim.addFrame("FeekStart/FeekPresents 13.png");
	
	ApplyColorMask(Black);
	font.drawText(sw/2-font.getStringWidth("Loading: Levels")/2,sh/2-8,"Loading: Levels");
	FlipScreen();
	
	NextLevel = 1;
	LoadLevels();
	
	Levels = new Array();
	Levels[0] = new Level;
	Levels[0].level = function() {GamePlay(1)}
	Levels[0].unlocked = false;
	Levels[0].difficulty = "Easy";
	Levels[1] = new Level;
	Levels[1].level = function() {GamePlay(2)}
	Levels[1].unlocked = false;
	Levels[1].difficulty = "Easy";
	Levels[2] = new Level;
	Levels[2].level = function() {GamePlay(3)}
	Levels[2].unlocked = false;
	Levels[2].difficulty = "Easy";
	Levels[3] = new Level;
	Levels[3].level = function() {GamePlay(4)}
	Levels[3].unlocked = false;
	Levels[3].difficulty = "Easy";
	Levels[4] = new Level;
	Levels[4].level = function() {GamePlay(5)}
	Levels[4].unlocked = false;
	Levels[4].difficulty = "Easy";
	Levels[5] = new Level;
	Levels[5].level = function() {GamePlay(6)}
	Levels[5].unlocked = false;
	Levels[5].difficulty = "Normal";	
	
	ApplyColorMask(Black);
	font.drawText(sw/2-font.getStringWidth("Loading: Menus")/2,sh/2-8,"Loading: Menus");
	FlipScreen();

	LevelMenu = new Menu(sw/2-90,sh/2-40,180);
	LevelMenu.name = "Level Selection";
	LevelMenu.addItem("Back to Main", GameMenu,White,Green);
	for (var i = 1; i < Levels.length+1; ++i)
	{
		LevelMenu.addItem(Levels[i-1].difficulty + " level " + i, Levels[i-1].level, Levels[i-1].unlocked);
	}
	
	MainMenu = new Menu(sw/2-90,sh/2-40,180);
	MainMenu.name = "Main Menu";
	MainMenu.addItem("Start Game",LevelSelection);
	MainMenu.addItem("Game Options",Options);
	MainMenu.addItem("Game Help",Help);
	MainMenu.addItem("Exit Game",Exit);
	
	InGameMenu = new Menu(sw/2-90,sh/2-40,180);
	InGameMenu.addItem("Return",Return);
	InGameMenu.addItem("Exit",LevelSelection);
	
	OptionsMenu = new Menu(sw/2-100,sh/2-40,200);
	OptionsMenu.name = "Options Menu";
	OptionsMenu.addItem("Clear Save Data",ClearSaveData);
	OptionsMenu.addItem("Back",GameMenu);
	
	mx           = GetMouseX();
	my           = GetMouseY();	
	cursor       = new Cursor()
	cursor.image = LoadImage("Cursor.png");
	
	LoadGame(); // to change data, after previous data has been set.
	
	ApplyColorMask(Black);
	font.drawText(sw/2-font.getStringWidth("Loading: Menus")/2,sh/2-8,"Loading: Menus");
	FadeOut(512);
}

function LoadLevels()
{ // yeah, I hand created them... No level making algorithems here...
	puzzle1 = new Puzzle("For Beginners",4,4,1)
	puzzle1.addBlock(false);
	puzzle1.addBlock(false);
	puzzle1.addNBlock(4);
	puzzle1.addNBlock(16);
	puzzle1.addBlock(false);
	puzzle1.addNBlock(5,7);
	puzzle1.addBlock(true);
	puzzle1.addBlock(true);
	puzzle1.addNBlock("n",8);
	puzzle1.addBlock(true);
	puzzle1.addBlock(true);
	puzzle1.addBlock(true);
	puzzle1.addBlock(false);
	puzzle1.addBlock(true);
	puzzle1.addBlock(false);
	puzzle1.addBlock(true);
	
	puzzle2 = new Puzzle("You can do it!",5,3,2)
	puzzle2.addBlock(false);
	puzzle2.addNBlock(4);
	puzzle2.addBlock(false);
	puzzle2.addNBlock(6);
	puzzle2.addNBlock(7);
	puzzle2.addNBlock("n",20);
	puzzle2.addBlock(true);
	puzzle2.addBlock(true);
	puzzle2.addBlock(true);
	puzzle2.addBlock(true);
	puzzle2.addNBlock("n",10);
	puzzle2.addBlock(true);
	puzzle2.addBlock(true);
	puzzle2.addBlock(true);
	puzzle2.addBlock(true);

	puzzle3 = new Puzzle("Try it out!", 4,5,3);
	puzzle3.addBlock(false);
	puzzle3.addBlock(false);
	puzzle3.addNBlock(20);
	puzzle3.addNBlock(9);
	puzzle3.addNBlock("n",15);
	puzzle3.addBlock(true);
	puzzle3.addBlock(true);
	puzzle3.addBlock(true);
	puzzle3.addBlock(false);
	puzzle3.addNBlock(3,5);
	puzzle3.addBlock(true);
	puzzle3.addBlock(true);
	puzzle3.addNBlock("n",12);
	puzzle3.addBlock(true);
	puzzle3.addBlock(true);
	puzzle3.addBlock(true);
	puzzle3.addBlock(false);
	puzzle3.addBlock(true);
	puzzle3.addBlock(true);
	puzzle3.addBlock(false);
	
	puzzle4 = new Puzzle("Get this one!",5,5,4)
	puzzle4.addBlock(false);
	puzzle4.addNBlock(21);
	puzzle4.addBlock(false);
	puzzle4.addNBlock(9);
	puzzle4.addNBlock(10);
	puzzle4.addNBlock("n",19);
	puzzle4.addBlock(true);
	puzzle4.addBlock(true);
	puzzle4.addBlock(true);
	puzzle4.addBlock(true);
	puzzle4.addNBlock("n",17);
	puzzle4.addBlock(true);
	puzzle4.addBlock(true);
	puzzle4.addBlock(true);
	puzzle4.addBlock(true);
	puzzle4.addBlock(false);
	puzzle4.addBlock(true);
	puzzle4.addNBlock("n",5);
	puzzle4.addBlock(true);
	puzzle4.addBlock(true);
	puzzle4.addNBlock("n",10);
	puzzle4.addBlock(true);
	puzzle4.addBlock(true);
	puzzle4.addBlock(false);
	puzzle4.addBlock(false);
	
	puzzle5 = new Puzzle("1, 2, 3!",5,5,5)
	puzzle5.addBlock(false);
	puzzle5.addNBlock(3);
	puzzle5.addNBlock(3);
	puzzle5.addBlock(false);
	puzzle5.addBlock(false);
	puzzle5.addNBlock("n",3);
	puzzle5.addBlock(true);
	puzzle5.addBlock(true);
	puzzle5.addBlock(false);
	puzzle5.addNBlock(3);
	puzzle5.addNBlock(3,3);
	puzzle5.addBlock(true);
	puzzle5.addBlock(true);
	puzzle5.addNBlock(3);
	puzzle5.addBlock(true);
	puzzle5.addBlock(true);
	puzzle5.addBlock(false);
	puzzle5.addNBlock("n",3);
	puzzle5.addBlock(true);
	puzzle5.addBlock(true);
	puzzle5.addBlock(true);
	puzzle5.addBlock(false);
	puzzle5.addBlock(false);
	puzzle5.addBlock(true);
	puzzle5.addBlock(false);
	
	puzzle6 = new Puzzle("Beast me",6,6,6)
	puzzle6.addBlock(false);
	puzzle6.addNBlock(21);
	puzzle6.addBlock(false);
	puzzle6.addNBlock(9);
	puzzle6.addNBlock(10);
	puzzle6.addBlock(false);
	
	puzzle6.addNBlock(4,13);
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addBlock(false);
	
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addBlock(false);
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addNBlock(6);
	
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addBlock(false);
	puzzle6.addBlock(false);
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	
	puzzle6.addNBlock("n",14);
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addBlock(false);
	puzzle6.addBlock(true);
	
	puzzle6.addBlock(false);
	puzzle6.addBlock(true);
	puzzle6.addNBlock("n",9);
	puzzle6.addBlock(true);
	puzzle6.addBlock(true);
	puzzle6.addBlock(false);
}

function BoxText(x,y,w,h,txt)
{
	window.drawWindow(x,y,w,h);
	font3.drawTextBox(x,y,w,h,0,txt);
}

function Help()
{
	while(!IsKeyPressed(KEY_ESCAPE))
	{
		image.blit(0,0);
		BoxText(sw/2-240,sh/2-100,480,200,"Kakuro is a mind game. It is played much like a crossword puzzle. In fact the game itself is called a cross sum puzzle game. "+
		"You can only use the numbers 1-9 in this game and they have to all equal their goal. You can't use the same number twice per row or column with an answer. Somt"+
		"imes two sums cross. In that case you will need to swap around numbers until all sums equal their goal. This game will tell you if the sums are right or wrong."+
		"\n\tPress ESC to go back...");
		cursor.Draw();
		FlipScreen();
	}
	ClearKeyQueue();
	Delay(200);
	GameMenu();
}

function LevelSelection()
{
	SaveGame();
	UnlockLevel(NextLevel);
	while(!IsKeyPressed(KEY_ESCAPE))
	{
		background.blit(0,0);
		LevelMenu.blit();
		cursor.Draw();
		FlipScreen();
	}
	GameMenu();
}

function UnlockLevel(level)
{
	LevelMenu.items[level].color = White;
	LevelMenu.items[level].highlight = BabyBlue;
}

function Options()
{
	image.blit(0,0);
	OptionsMenu.draw();
}